<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/DocBook/Markup/Javadoc.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/DocBook/Markup/Javadoc.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/DocBook/Markup/Javadoc.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.DocBook.Markup <span class="py-keyword">import</span> *</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">import</span> re</span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#attributes">attributes</a>(keys):</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">    <span class="py-string">&quot;Convert a name/value dict to a string of attributes&quot;</span></span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">''</span>.join([<span class="py-string">'%s=&quot;%s&quot;'</span>%(k,v) <span class="py-keyword">for</span> k,v <span class="py-keyword">in</span> keys.items()])</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#element">element</a>(_type, body, **keys):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-string">&quot;Wrap the body in a tag of given type and attributes&quot;</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">'&lt;%s %s&gt;%s&lt;/%s&gt;'</span>%(_type,attributes(keys),body,_type)</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#title">title</a>(name) : <span class="py-keyword">return</span> element(<span class="py-string">'title'</span>, name)</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#para">para</a>(body) : <span class="py-keyword">return</span> element(<span class="py-string">'para'</span>, body)</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#listitem">listitem</a>(body) : <span class="py-keyword">return</span> element(<span class="py-string">'listitem'</span>, body)</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#term">term</a>(body) : <span class="py-keyword">return</span> element(<span class="py-string">'term'</span>, body)</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc.html#link">link</a>(linkend, label) : <span class="py-keyword">return</span> element(<span class="py-string">'link'</span>, label, linkend=linkend)</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html">Javadoc</a>(Formatter):</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="py-string">    A formatter that formats comments similar to Javadoc.</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-string">    See `Javadoc Spec`_ for info.</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-string"/></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-string">    .. _Javadoc Spec: http://java.sun.com/j2se/1.5.0/docs/tooldocs/solaris/javadoc.html&quot;&quot;&quot;</span></span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    <span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc/Block.html">Block</a>:</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc/Block.html#__init__">__init__</a>(self, tag, arg, body):</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">            self.tag, self.arg, self.body = tag, arg, body</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">    summary = <span class="py-string">r'(\s*[\w\W]*?\.)(\s|$)'</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">    block_tag = <span class="py-string">r'(^\s*\@\w+[\s$])'</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">    inline_tag = <span class="py-string">r'{@(?P&lt;tag&gt;\w+)\s+(?P&lt;content&gt;[^}]+)}'</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">    inline_tag_split = <span class="py-string">r'({@\w+\s+[^}]+})'</span></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    xref = <span class="py-string">r'([\w#.]+)(?:\([^\)]*\))?\s*(.*)'</span></span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">    tag_name = {</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-string">'author'</span>: [<span class="py-string">'Author'</span>, <span class="py-string">'Authors'</span>],</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">    <span class="py-string">'date'</span>: [<span class="py-string">'Date'</span>, <span class="py-string">'Dates'</span>],</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">    <span class="py-string">'deprecated'</span>: [<span class="py-string">'Deprecated'</span>, <span class="py-string">'Deprecated'</span>],</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">    <span class="py-string">'exception'</span>: [<span class="py-string">'Exception'</span>, <span class="py-string">'Exceptions'</span>],</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">    <span class="py-string">'invariant'</span>: [<span class="py-string">'Invariant'</span>, <span class="py-string">'Invariants'</span>],</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-string">'keyword'</span>: [<span class="py-string">'Keyword'</span>, <span class="py-string">'Keywords'</span>],</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">    <span class="py-string">'param'</span>: [<span class="py-string">'Parameter'</span>, <span class="py-string">'Parameters'</span>],</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">    <span class="py-string">'postcondition'</span>: [<span class="py-string">'Postcondition'</span>, <span class="py-string">'Postcondition'</span>],</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">    <span class="py-string">'precondition'</span>: [<span class="py-string">'Precondition'</span>, <span class="py-string">'Preconditions'</span>],</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <span class="py-string">'return'</span>: [<span class="py-string">'Returns'</span>, <span class="py-string">'Returns'</span>],</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">    <span class="py-string">'see'</span>: [<span class="py-string">'See also'</span>, <span class="py-string">'See also'</span>],</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <span class="py-string">'throws'</span>: [<span class="py-string">'Throws'</span>, <span class="py-string">'Throws'</span>],</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    <span class="py-string">'version'</span>: [<span class="py-string">'Version'</span>, <span class="py-string">'Versions'</span>]}</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">    arg_tags = [<span class="py-string">'param'</span>, <span class="py-string">'keyword'</span>, <span class="py-string">'exception'</span>]</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#__init__">__init__</a>(self):</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Create regex objects for regexps&quot;&quot;&quot;</span></span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        self.summary = re.compile(Javadoc.summary)</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        self.block_tag = re.compile(Javadoc.block_tag, re.M)</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        self.inline_tag = re.compile(Javadoc.inline_tag)</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        self.inline_tag_split = re.compile(Javadoc.inline_tag_split)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        self.xref = re.compile(Javadoc.xref)</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#split">split</a>(self, doc):</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Split a javadoc comment into description and blocks.&quot;&quot;&quot;</span></span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        chunks = self.block_tag.split(doc)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        description = chunks[0]</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        blocks = []</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(1, len(chunks)):</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">            <span class="py-keyword">if</span> i % 2 == 1:</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">                tag = chunks[i].strip()[1:]</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">                <span class="py-keyword">if</span> tag <span class="py-keyword">in</span> self.arg_tags:</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">                    arg, body = chunks[i].strip().split(None, 1)</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">                    arg, body = None, chunks[i]</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">                <span class="py-keyword">if</span> tag == <span class="py-string">'see'</span> <span class="py-keyword">and</span> body:</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">                    <span class="py-keyword">if</span> body[0] <span class="py-keyword">in</span> [<span class="py-string">'&quot;'</span>, <span class="py-string">&quot;'&quot;</span>]:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">                        <span class="py-keyword">if</span> body[-1] == body[0]:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">                            body = body[1:-1]</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">                    <span class="py-keyword">elif</span> body[0] == <span class="py-string">'&lt;'</span>:</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">                        <span class="py-keyword">pass</span></span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">                    <span class="py-keyword">else</span>:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                        <span class="py-comment"># @link tags are interpreted as cross-references</span></span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">                        <span class="py-comment">#       and resolved later (see format_inline_tag)</span></span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                        body = <span class="py-string">'{@link %s}'</span>%body</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                blocks.append(Javadoc.Block(tag, arg, body))</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">return</span> description, blocks</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#extract_summary">extract_summary</a>(self, description):</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Generate a summary from the given description.&quot;&quot;&quot;</span></span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">        m = self.summary.match(description)</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        <span class="py-keyword">if</span> m:</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">'&lt;para&gt;%s&lt;/para&gt;\n'</span>%m.group(1)</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">'&lt;para&gt;%s&lt;/para&gt;\n'</span>%(description.split(<span class="py-string">'\n'</span>, 1)[0]+<span class="py-string">'...'</span>)</span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format">format</a>(self, decl):</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Format using javadoc markup.&quot;&quot;&quot;</span></span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        doc = decl.annotations.get(<span class="py-string">'doc'</span>)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        doc = doc <span class="py-keyword">and</span> doc.text <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> doc:</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            <span class="py-keyword">return</span> Struct(<span class="py-string">''</span>, <span class="py-string">''</span>)</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        description, blocks = self.split(doc)</span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        details = self.format_description(description, decl)</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        summary = self.extract_summary(details)</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        details += self.format_params(blocks, decl)</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        details += self.format_variablelist(<span class="py-string">'return'</span>, blocks, decl)</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        details += self.format_throws(blocks, decl)</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        vl = self.format_varlistentry(<span class="py-string">'precondition'</span>, blocks, decl)</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'postcondition'</span>, blocks, decl)</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'invariant'</span>, blocks, decl)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'author'</span>, blocks, decl)</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'date'</span>, blocks, decl)</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'version'</span>, blocks, decl)</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'deprecated'</span>, blocks, decl)</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        vl += self.format_varlistentry(<span class="py-string">'see'</span>, blocks, decl)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        <span class="py-keyword">if</span> vl:</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">            details += <span class="py-string">'&lt;variablelist&gt;\n%s\n&lt;/variablelist&gt;\n'</span>%vl</span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        <span class="py-keyword">return</span> Struct(summary, details)</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_description">format_description</a>(self, text, decl):</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;para&gt;%s&lt;/para&gt;\n'</span>%self.format_inlines(decl, text)</span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_inlines">format_inlines</a>(self, decl, text):</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats inline tags in the text.&quot;&quot;&quot;</span></span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        chunks = self.inline_tag_split.split(text)</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">        text = <span class="py-string">''</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line">        <span class="py-comment"># Every other chunk is now an inlined tag, which we process</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        <span class="py-comment"># in this loop.</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(len(chunks)):</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            <span class="py-keyword">if</span> i % 2 == 0:</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">                text += chunks[i]</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">                m = self.inline_tag.match(chunks[i])</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">                <span class="py-keyword">if</span> m:</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">                    text += self.format_inline_tag(m.group(<span class="py-string">'tag'</span>),</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">                                                   m.group(<span class="py-string">'content'</span>),</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">                                                   decl)</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        <span class="py-keyword">return</span> text</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_params">format_params</a>(self, blocks, decl):</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats a list of (param, description) tags&quot;&quot;&quot;</span></span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        content = <span class="py-string">''</span></span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        params = [b <span class="py-keyword">for</span> b <span class="py-keyword">in</span> blocks <span class="py-keyword">if</span> b.tag == <span class="py-string">'param'</span>]</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        <span class="py-keyword">if</span> params:</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">            params = [element(<span class="py-string">'varlistentry'</span>, term(p.arg) + listitem(para(p.body)))</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">                      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> params]</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">            content += element(<span class="py-string">'variablelist'</span>,</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">                               title(<span class="py-string">'Parameters'</span>) + <span class="py-string">'\n'</span> + <span class="py-string">'\n'</span>.join(params))</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">        kwds = [b <span class="py-keyword">for</span> b <span class="py-keyword">in</span> blocks <span class="py-keyword">if</span> b.tag == <span class="py-string">'keyword'</span>]</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">        <span class="py-keyword">if</span> kwds:</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">            kwds = [element(<span class="py-string">'varlistentry'</span>, term(k.arg) + listitem(para(k.body)))</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">                    <span class="py-keyword">for</span> k <span class="py-keyword">in</span> kwds]</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">            content += element(<span class="py-string">'variablelist'</span>,</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">                               title(<span class="py-string">'Keywords'</span>) + <span class="py-string">'\n'</span> + <span class="py-string">'\n'</span>.join(kwds))</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        <span class="py-keyword">return</span> content</span>
<a id="line181"></a><span class="lineno">181</span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_throws">format_throws</a>(self, blocks, decl):</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">        content = <span class="py-string">''</span></span>
<a id="line186"></a><span class="lineno">186</span><span class="line">        throws = [b <span class="py-keyword">for</span> b <span class="py-keyword">in</span> blocks <span class="py-keyword">if</span> b.tag <span class="py-keyword">in</span> [<span class="py-string">'throws'</span>, <span class="py-string">'exception'</span>]]</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">        <span class="py-keyword">if</span> throws:</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">            throws = [element(<span class="py-string">'varlistentry'</span>, term(t.arg) + listitem(para(t.body)))</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">                      <span class="py-keyword">for</span> t <span class="py-keyword">in</span> throws]</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">            content += element(<span class="py-string">'variablelist'</span>,</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">                               title(<span class="py-string">'Throws'</span>) + <span class="py-string">'\n'</span> + <span class="py-string">'\n'</span>.join(throws))</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">        <span class="py-keyword">return</span> content</span>
<a id="line193"></a><span class="lineno">193</span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_variablelist">format_variablelist</a>(self, tag, blocks, decl):</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line197"></a><span class="lineno">197</span><span class="line"><span class="py-string">        Generate a variablelist for the given tag.</span></span>
<a id="line198"></a><span class="lineno">198</span><span class="line"><span class="py-string">        Each matching block is formatted to a varlistentry, with the value</span></span>
<a id="line199"></a><span class="lineno">199</span><span class="line"><span class="py-string">        of its 'arg' member becoming the term.&quot;&quot;&quot;</span></span>
<a id="line200"></a><span class="lineno">200</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">        content = <span class="py-string">''</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line">        items = [b <span class="py-keyword">for</span> b <span class="py-keyword">in</span> blocks <span class="py-keyword">if</span> b.tag == tag]</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">        <span class="py-keyword">if</span> items:</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">            items = [element(<span class="py-string">'varlistentry'</span>, term(i.arg) + listitem(para(self.format_inlines(decl, i.body))))</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">                     <span class="py-keyword">for</span> i <span class="py-keyword">in</span> items]</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">            content += element(<span class="py-string">'variablelist'</span>,</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">                               title(self.tag_name[tag][1]) + <span class="py-string">'\n'</span> + <span class="py-string">'\n'</span>.join(items))</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        <span class="py-keyword">return</span> content</span>
<a id="line209"></a><span class="lineno">209</span>
<a id="line210"></a><span class="lineno">210</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_varlistentry">format_varlistentry</a>(self, tag, blocks, decl):</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">        <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line213"></a><span class="lineno">213</span><span class="line"><span class="py-string">        Generate a varlistentry for the given tag.</span></span>
<a id="line214"></a><span class="lineno">214</span><span class="line"><span class="py-string">        The tag value itself becomes the term. If multiple blocks match,</span></span>
<a id="line215"></a><span class="lineno">215</span><span class="line"><span class="py-string">        format them as an (inlined) simplelist, otherwise as a para.&quot;&quot;&quot;</span></span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">        items = [b <span class="py-keyword">for</span> b <span class="py-keyword">in</span> blocks <span class="py-keyword">if</span> b.tag == tag]</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> items:</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line220"></a><span class="lineno">220</span><span class="line">        <span class="py-keyword">if</span> len(items) &gt; 1:</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">            items = [element(<span class="py-string">'member'</span>, self.format_inlines(decl, i.body)) <span class="py-keyword">for</span> i <span class="py-keyword">in</span> items]</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">            content = element(<span class="py-string">'simplelist'</span>, <span class="py-string">'\n'</span>.join(items), type=<span class="py-string">'inline'</span>) + <span class="py-string">'\n'</span></span>
<a id="line223"></a><span class="lineno">223</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">            content = element(<span class="py-string">'para'</span>, self.format_inlines(decl, items[0].body))</span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">        <span class="py-keyword">return</span> element(<span class="py-string">'varlistentry'</span>, term(self.tag_name[tag][1]) + <span class="py-string">'\n'</span> + listitem(content))</span>
<a id="line227"></a><span class="lineno">227</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/DocBook/Markup/Javadoc/Javadoc.html#format_inline_tag">format_inline_tag</a>(self, tag, content, decl):</span>
<a id="line230"></a><span class="lineno">230</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">        text = <span class="py-string">''</span></span>
<a id="line232"></a><span class="lineno">232</span><span class="line">        <span class="py-keyword">if</span> tag == <span class="py-string">'link'</span>:</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">            xref = self.xref.match(content)</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">            name, label = xref.groups()</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> label:</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">                label = name</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">            <span class="py-comment"># javadoc uses '{@link  package.class#member  label}'</span></span>
<a id="line238"></a><span class="lineno">238</span><span class="line">            <span class="py-comment"># Here we simply replace '#' by either '::' or '.' to match</span></span>
<a id="line239"></a><span class="lineno">239</span><span class="line">            <span class="py-comment"># language-specific qualification rules.</span></span>
<a id="line240"></a><span class="lineno">240</span><span class="line">            <span class="py-keyword">if</span> <span class="py-string">'#'</span> <span class="py-keyword">in</span> name:</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">                <span class="py-keyword">if</span> <span class="py-string">'::'</span> <span class="py-keyword">in</span> name:</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">                    name = name.replace(<span class="py-string">'#'</span>, <span class="py-string">'::'</span>)</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">                    name = name.replace(<span class="py-string">'#'</span>, <span class="py-string">'.'</span>)</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">            target = self.lookup_symbol(name, decl.name[:-1])</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">            <span class="py-keyword">if</span> target:</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">                text += link(target, label)</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">                text += label</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">        <span class="py-keyword">elif</span> tag == <span class="py-string">'code'</span>:</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">            text += <span class="py-string">'&lt;code&gt;%s&lt;/code&gt;'</span>%escape(content)</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">        <span class="py-keyword">elif</span> tag == <span class="py-string">'literal'</span>:</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">            text += <span class="py-string">'&lt;literal&gt;%s&lt;/literal&gt;'</span>%escape(content)</span>
<a id="line254"></a><span class="lineno">254</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">        <span class="py-keyword">return</span> text</span>
<a id="line256"></a><span class="lineno">256</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
